<template>
<view>
<image src="/static/icon/background-from.png" class="background"></image>
<view class="project-content">
	<u-form :model="form" :rules="rules" ref="form">
		<u-form-item label="楼栋" borderBottom ref="item1" labelWidth="140">
			<u-input v-model="buildingName" disabled borderBottom @click=" showbuilding= true&&type!=1"
				placeholder="请选择楼栋"></u-input>
			<u-select v-model="showbuilding" :list="buildingList" label-name="name" value-name="id"
				@confirm="buildingconfirm()"> </u-select>
			<u-icon slot="right" name="arrow-right"></u-icon>
		</u-form-item>
		<!-- <u-form-item label="单元" labelWidth="140" borderBottom ref="item1">
			<u-input v-model="unitName" disabled borderBottom @click=" showunit= true&&type!=1"
				placeholder="请选择单元"></u-input>
			<u-select v-model="showunit" :list="unitList" label-name="name" value-name="id"
				@confirm="unitconfirm()"> </u-select>
			<u-icon slot="right" name="arrow-right"></u-icon>
		</u-form-item> -->
		<u-form-item label="发现问题" labelWidth="140" borderBottom ref="item1">
			<u-input v-model="causesOfFamageLabel" disabled @click=" showrepairType= true&&type!=1" borderBottom
				placeholder="请输入发现问题"></u-input>
			<u-select v-model="showrepairType" :list="typelist.find_problem" label-name="dictLabel"
				value-name="dictValue" @confirm="confirm()"> </u-select>
			<u-icon slot="right" name="arrow-right"></u-icon>
		</u-form-item>
		<u-form-item borderBottom ref="item1">
			<view>备注</view>
			<u-input v-model="form.remarks" type="textarea" placeholder="请输入备注" :disabled="type==1"></u-input>
		</u-form-item>
		<u-form-item borderBottom ref="item1">
			<view>巡检照片</view>
			<u-input v-model="WarningColumnInformation" disabled placeholder="请上传巡检照片"></u-input>
			<view class="" style="display: flex; flex-wrap: wrap; margin: 0 55rpx;">
				<image src="/static/icon/chooseimg.png" mode=""
					style="width: 190rpx; height: 190rpx; margin: 0 12rpx; " @click="choose()" v-if="type!=1">
				</image>
				<view v-for="(item,index) in imgymxs" :key="index" style="position: relative;">
					<view v-if="item.type == 'image'">
						<image :src="item.url" mode="" style="width: 190rpx; height: 190rpx; margin: 0 20rpx;"
							@click="showPhoto(index)">
						</image>
					</view>
					<view v-else>
						<video :src="item" style="width: 190rpx; height: 190rpx; margin: 0 20rpx;"></video>
					</view>
					<view @click="remove(index)"
						style="position: absolute; top: 0; right: 14rpx; border-radius: 50%; background-color: #FF0000;">
						<u-icon name="close" color="#FFFFFF" size="35" v-if="type!=1"></u-icon>
					</view>
				</view>
			</view>
		</u-form-item>
	</u-form>
	<u-button style="background: #2d95f4;color: #fff;border-radius: 20rpx;" @click="save()" v-if="type!=1"
		type='primary'>确认上传</u-button>
</view>
</view>
</template>
<script>
import service from '@/api/index.js'
export default {
data() {
	return {
		repairType: [{
			label: '施工问题',
			value: 1
		}, {
			label: '施工问题',
			value: 2
		}, ],
		showrepairType: false,
		action: this.$HTTP.webUrl + `/obs`,
		headers: {
			MAuthorization: "wxBearer " + uni.getStorageSync('token')
		},
		url: [],
		uploading: false,
		imgArr: [],
		imgymxs: [],
		progress: 0, //图片或视频上传百分比
		form: {},
		typelist: [],
		causesOfFamageLabel: null,
		dictlist: ['find_problem'],
		buildingName: null,
		unit: null,
		unitName: null,
		showbuilding: false,
		showunit: false,
		buildingList: [],
		unitList: [],
		type: 2,
		id: null,
		community: null,
		createBy:null
	}
},
onLoad(e) {
	this.building = e.building
	this.buildingName = e.buildingName
	this.community = e.community
	this.unitName = e.unitName
	this.unit = e.unit
	this.id = e.id
	this.type = e.type
	console.log(e)
	this.getdictsysinfo()
	uni.setNavigationBarTitle({
		title: '庭院网管表单'
	});
	uni.setNavigationBarColor({
		frontColor: '#ffffff',
		backgroundColor: '#2d95f4',
	})
	if (this.type != 1) {
		this.getBuildingList()
	}
	this.getUserName()
},
methods: {
	getUserName(){
		service.getUserName().then(res=>{
			this.userId=res.id
			thuis.createBy=res.name
		})
	},
	showPhoto(index) {
		uni.previewImage({
			current: index,
			urls: this.imgArr,
		})
	},
	showPhotos(index) {
		uni.previewImage({
			current: index,
			urls: this.photo,
		})
	},
	buildingconfirm(e) {
		this.buildingName = e[0].label
		this.building = e[0].value
		console.log(this.building)
		//this.getUnitList(e[0].value)
	},
	unitconfirm(e) {
		this.unitName = e[0].label
		this.unit = e[0].value
	},
	getBuildingList() {
		const _this = this
		service.getBuildingList({
			areaId: this.community
		}).then(res => {
			_this.buildingList = res
		})
	},
	getUnitList(building) {
		const _this = this
		service.getUnitList({
			buildingId: building
		}).then(res => {
			_this.unitList = res
		})
	},
	save() {
		let _this = this
		this.form.photoList = this.imgArr
		if(this.building==null)
		{
			uni.showToast({
				title: '请选择楼栋',
				icon: 'none'
			})
			return
		}
		if(this.imgArr.length==0)
		{
			uni.showToast({
				title: '请上传图片或视频！',
				icon: 'none'
			})
			return
		}
		this.form.buildingId = this.building
		this.form.communityId=this.community
		this.form.userId=this.userId
		this.form.createBy=this.userId
		service.setcourtyardNetworkManagement(this.form).then(res => {
			console.log(res)
			_this.$UTILS.showPrompt('上报成功！')
			// setTimeout(() => {
			// 	console.log('跳')
			// 	uni.switchTab({
			// 		url: '/pages/index/index'
			// 	})
			// }, 2000)
			this.form={}
			this.buildingName=''
			this.causesOfFamageLabel=''
			this.imgArr=[]
			this.imgymxs=[]
		})
	},
	getdictsysinfo() {
		let _this = this
		service.getDictInfoList({
			type: this.dictlist
		}).then(res => {
			if (this.type == 1) {
				let _this = this
				console.log(this.id)
				service.getcourtyardNetworkManagement(this.id).then(res => {
					console.log(_this.typelist)
					_this.buildingName = res.buildingName
					_this.unitName = res.unitName
					let list = []
					list = _this.typelist.find_problem
					list.forEach((item) => {
						if (item.dictValue == res.findProblem) {
							_this.causesOfFamageLabel = item.dictLabel
						}
					})
					if (null != res.photoList) {
						res.photoList.forEach(item => {
							let url = {}
							url.url = item
							url.type = 'image'
							this.imgymxs.push(url)
						})
					}
					this.form = res
				})
			}
			_this.typelist = res
			console.log(res)
		})
	},
	confirm(e) {
		console.log(e)
		this.causesOfFamageLabel = e[0].label
		this.form.findProblem = e[0].value
	},
	choose() {
		let _this = this;
		uni.showActionSheet({
			title: '上传',
			itemList: ['图片', '视频'],
			success: (res) => {
				// console.log(res)
				if (res.tapIndex == 0) {
					this.chooseimage()
				} else {
					this.choosevideo()
				}
			}
		})
	},
	chooseimage() {
		console.log('图片')
		let _this = this;
		uni.chooseImage({
			sourceType: ['camera'],
			success(resp) {
				console.log('res--uni.chooseMedia', resp);
				resp.tempFiles.forEach((item, index) => {
					const task = uni.uploadFile({
						url: _this.$HTTP.webUrl + `/obs`,
						filePath: item.path,
						name: 'file',
						formData: {},
						header: _this.headers,
						success: res => {
							// 判断是否json字符串，将其转为json格式
							let data = _this.$u.test.jsonString(res.data) ? JSON.parse(
								res.data) : res.data;
							if (![200, 201, 204].includes(res.statusCode)) {
								// this.uploadError(index, data);
								_this.$UTILS.showPrompt('选取失败！')
							} else {
								// 上传成功
								// this.lists[index].response = data;
								// this.lists[index].progress = 100;
								// this.lists[index].error = false;
								// this.$emit('on-success', data, index, this.lists, this
								// 	.index);
								if (_this.progress === 100) {
									// console.log('_this.progress', _this.progress)
									// console.log('data----', data)
									// console.log('res--', res)
									_this.imgymxs.push({
										url: data.data.url,
										type: 'image'
									})
									_this.imgArr.push(data.data.url)
									// console.log('imgArr', _this.imgArr)
									_this.$UTILS.showPrompt('选取成功！')
								}
							}
						},
						fail: e => {
							_this.$UTILS.showPrompt('选取失败！')
							this.uploadError(index, e);
						},
						complete: res => {
							_this.uploading = false;
							// _this.uploadFile(index + 1);
							// this.$emit('on-change', res, index, this.lists, this
							// .index);
						}
					});
					task.onProgressUpdate(res => {
						// if (res.progress > 0) {
						// 	this.lists[index].progress = res.progress;
						// 	this.$emit('on-progress', res, index, this.lists, this.index);
						// }
						_this.progress = res.progress;
						console.log('onProgressUpdate', res)
						uni.showLoading({
							title: '选取中'
						})
					});
				})
			},
		})
	},
	choosevideo() {
		let _this = this;
		console.log('视频')
		uni.chooseVideo({
			sourceType: ['camera'],
			maxDuration: 30,
			success(resp) {
				const task = uni.uploadFile({
					url: _this.$HTTP.webUrl + `/obs`,
					filePath: resp.tempFilePath,
					name: 'file',
					formData: {},
					header: _this.headers,
					success: res => {
						// 判断是否json字符串，将其转为json格式
						let data = _this.$u.test.jsonString(res.data) ? JSON.parse(res.data) :
							res.data;
						if (![200, 201, 204].includes(res.statusCode)) {
							this.uploadError(index, data);
						} else {
							// 上传成功
							// this.lists[index].response = data;
							// this.lists[index].progress = 100;
							// this.lists[index].error = false;
							// this.$emit('on-success', data, index, this.lists, this
							// 	.index);	
							if (_this.progress === 100) {
								console.log('_this.progress', _this.progress)
								console.log('data----', data)
								console.log('res--', res)
								// _this.imgArr.push(data.data.url)
								_this.imgymxs.push({
									url: data.data.url,
									type: 'video'
								})
								_this.imgArr.push(data.data.url)
								console.log('imgArr', _this.imgArr)
								_this.$UTILS.showPrompt('选取成功！')
							}
						}
					},
					fail: e => {
						_this.$UTILS.showPrompt('选取失败！')
						this.uploadError(index, e);
					},
					complete: res => {
						uni.hideLoading();
						_this.uploading = false;
						// _this.uploadFile(index + 1);
						// this.$emit('on-change', res, index, this.lists, this
						// .index);
					}
				});
				task.onProgressUpdate(res => {
					// if (res.progress > 0) {
					// 	this.lists[index].progress = res.progress;
					// 	this.$emit('on-progress', res, index, this.lists, this.index);
					// }
					_this.progress = res.progress;
					console.log('onProgressUpdate', res)
					uni.showLoading({
						title: '选取中'
					})
				});
			},
		})
	},
	remove(index) {
		uni.showModal({
			title: '提示',
			content: '是否删除该图片或视频？',
			success: (res) => {
				if (res.confirm) {
					this.imgArr.splice(index, 1);
					this.imgymxs.splice(index, 1);
					console.log('this.imgarr', this.imgArr)
				}
			}
		})
	},
}
}
</script>
<style>
.project-content {
padding: 10rpx 20rpx;
border-radius: 20rpx;
background: #fff;
width: 90%;
margin: 0 auto;
}

.background {
z-index: -1;
position: fixed;
width: 100%;
height: 100%;
background-size: 100% 100%;
}
</style>